/*
 * @copyright   © Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module      de_epages.multistore.inc.affiliateitems
 */

/*jslint browser: true, nomen: true, regexp: true, evil: true, forin: true*/
/*global define, epages*/

define("de_epages/multistore/inc/affiliateitems", [
    "jquery",
], function ($) {

    'use strict';

    var affiliateList = {},

        affiliateitems = {
            init: function (list) {
                affiliateList = list;

                return this;
            },

            addDataToItems: function (checkboxes) {
                // var checkboxes = richtable.find('input[type=checkbox][name=ListObjectID]');

                // iterate over all input boxes
                checkboxes.each(function () {
                    var $this = $(this);

                    // set data attribute "true" if current item is an item from a MasterShop
                    $this.data('isAffiliate', !!affiliateList[$(this).val()]);
                });

                return this;
            },

            // disables BatchAction-group by name (batchAction) if activeRows contains at least one affiliate item
            // @activeRows:   (object) array with input elements
            // @batchActions: (string) name of the BatchAction (e.g. "Delete")
            disableBatchAction: function (activeRows, batchAction) {
                var //activeRows =  richtable.find('tbody tr td:first-child input[type=checkbox]:checked'),
                    disableBatchAction = false;

                // iterate over selected rows/inputs
                activeRows.each(function () {
                    var input = $(this);

                    // if data attribute to indicate "master product" is set
                    // => mark that selection contains a "master product"
                    if (input.data('isAffiliate')) {
                        disableBatchAction = true;
                        return false;
                    }
                });

                // if selection contains a "master product" => disable delete action
                if (disableBatchAction && activeRows.length) {
                    $('.ep-batchActions-groupImage-' + batchAction)
                        .closest('label')
                        .addClass('BatchActionDisabled');
                }

                return this;
            }
        };

    return affiliateitems;
});
